// simple CAVE emulation

// (c) 2000 Michal Husak husakm@vscht.cz 
#ifndef __CAVE_OGL
	#define __CAVE_OGL

#ifdef WIN32
	#include<GL/glut.h> 
	#include<windows.h>   
#else
	#include "glut.h"    // Header File For The GLUT Libry
#endif
#include <stdlib.h>
#include <math.h>

// constants (key codes) the key are small (AKEY = a code)
// folowing keys are reserved for cave visualisation c,l,r,f,b
// 1,2,3,4 keys are reserved for cavebuton emulations
#define CAVE_ESCKEY 27
#define CAVE_AKEY 97
#define CAVE_DKEY 100
#define CAVE_EKEY 101
#define CAVE_FKEY 102
#define CAVE_GKEY 103
#define CAVE_HKEY 104
#define CAVE_IKEY 105


// cavebutons corresponds to 1,2,3,4 numbers
#define CAVEBUTTON1 CAVEgetbutton(49)  
#define CAVEBUTTON2 CAVEgetbutton(50)  
#define CAVEBUTTON3 CAVEgetbutton(51)  
#define CAVEBUTTON4 CAVEgetbutton(52)  


// emulate CAVEmalloc as normal malloc
#define CAVEMalloc malloc

	#ifdef __cplusplus
		extern "C" {
	#endif


void	CAVEConfigure(int* argc,char** argv,void* test);

void	CAVEInit();
	
void	CAVEInitApplication(void (*gl_init_fn)(),int i);

void	CAVEDisplay(void (*draw_fn)(), int i);
	
void	CAVEExit();

void	CAVE_PC_emu_idle(void (*idle_fn)());

int		CAVEgetbutton(unsigned int key);

	#ifdef __cplusplus
		}
	#endif

#endif